-- Light Placer 1.0 by xcEmUx
-- Use and Modifiy on your own risk

rollout Lightplacer "LightPlacer"
(
spinner lsubdivs "Subdivs:" range:[1,48,8] type:#integer offset:[0,25]
spinner lmultiplier "Multiplier:" range:[0.1, 1000.0, 25.0]
spinner lradius "Radius:" range:[0.05, 100.0, 1.0]
colorpicker clrpick "Pick Color" color:white align:#left
checkbox chkvisible "Invisible" checked:false align:#left
label lbl1 "Place On:" align:#left
radiobuttons sctype labels:#("Verticies" , "Faces") align:#center
dropdownlist ddsteps "Steps:" items:#("1" , "2", "3", "4" , "8") height: 5 width: 50 align:#left
pickbutton pick "Pick Objekt" 
label lbl2 " "
button btndelete "Delete Lights" height:16 width:80
button btncolors "Random Colors" height: 16 width:80
button btnrender "Render" height: 16 width: 80
progressbar progress "Progress" color:blue
button help "?" height:15 width:15 align:#center border:false offset: [0,3]
groupbox grpbx1 "Light Placer 1.0" pos:[5,5] width: 115 height: 360

global positionarray =#()
	
on pick picked obj do
(

	pick.text = obj.name 
	
if sctype.state == 1 then 
(

	addmodifier obj (Edit_Mesh())
	gnv = getnumverts obj
	
		for i = 1 to gnv by ddsteps.selected as integer do
		(
	
			progress.value = 100.0 * i / Positionarray.count 
			gv = getvert obj i 
			positionarray [i] = vraylight type:2 pos:gv subdivs:lsubdivs.value multiplier: lmultiplier.value size0:lradius.value color:clrpick.color invisible:chkvisible.checked
			-- For NonVray User replace the line above with the following code:
			-- positionarray [i] = omnilight pos:gv */  subdvis: NOTAVAILABLE */  multiplier: lmultiplier.value */  Size: NOTAVAILABLE */  rgb: clrpick.color */ invisible: NOTAVAILABLE */ 
			
			max views redraw
			
		) --ende for loop
)

if sctype.state == 2 then
(
	
	addmodifier obj (Edit_Poly())
	gnv = getnumfaces obj
	
		for i = 1 to gnv by ddsteps.selected as integer do
		(
	
			progress.value = 100.0 * i / Positionarray.count 
			gv = polyop.getfacecenter obj i 
			positionarray [i] = vraylight type:2 pos:gv subdivs:lsubdivs.value multiplier: lmultiplier.value size0:lradius.value color:clrpick.color invisible:chkvisible.checked
			-- For NonVray User replace the line above with the following code:
			-- positionarray [i] = omnilight pos:gv */  subdvis: NOTAVAILABLE */  multiplier: lmultiplier.value */  Size: NOTAVAILABLE */  rgb: clrpick.color */ invisible: NOTAVAILABLE */ 
			
			max views redraw
			
		) --ende for loop
	
)

) --ende pickbutton

on lsubdivs changed value do
	
(
	for i = 1 to positionarray.count do
		
	(
		
		positionarray [i].subdivs = lsubdivs.value
		
	) --ende for loop
	
)--ende lsubdivs

on lmultiplier changed value do
	
(
	for i = 1 to positionarray.count do
		
	(
		
		positionarray [i].multiplier = lmultiplier.value
		
	) --ende for loop
	
)--ende lmultiplier

on lradius changed value do
	
(
	for i = 1 to positionarray.count do
		
	(
		
		positionarray [i].size0 = lradius.value
		
	) --ende for loop
	
)--ende lradius

on chkvisible changed thestate do
	
(
	for i = 1 to positionarray.count do
		
	(
		
		positionarray [i].invisible = not positionarray [i].invisible
		
	)--ende for loop
	
)--ende chkvisible

on clrpick changed color do
	
(
	for i = 1 to positionarray.count do
		
	(
		
		positionarray [i].color = clrpick.color 
		
	) --ende for loop
	
	
) --ende clrpick

on ddsteps selected thesteps do
(
	
	if sctype.state == 1 then 
	(

		addmodifier pick.object (Edit_Mesh())
		gnv = getnumverts pick.object
	
		for i = 1 to gnv by ddsteps.selected as integer do
		(
	
			progress.value = 100.*i/Positionarray.count 
			gv = getvert pick.object i 
			positionarray [i] = vraylight type:2 pos:gv subdivs:lsubdivs.value multiplier: lmultiplier.value size0:lradius.value color:clrpick.color invisible:chkvisible.checked
			-- For NonVray User replace the line above with the following code:
			-- positionarray [i] = omnilight pos:gv */  subdvis: NOTAVAILABLE */  multiplier: lmultiplier.value */  Size: NOTAVAILABLE */  rgb: clrpick.color */ invisible: NOTAVAILABLE */ 
			
			max views redraw
			
		) --ende for loop
	)

	if sctype.state == 2 then
	(
	
		addmodifier pick.object (Edit_Poly())
		gnv = getnumfaces pick.object
	
		for i = 1 to gnv by ddsteps.selected as integer do
		(
	
			progress.value = 100.*i/Positionarray.count 
			gv = polyop.getfacecenter pick.object i 
			positionarray [i] = vraylight type:2 pos:gv subdivs:lsubdivs.value multiplier: lmultiplier.value size0:lradius.value color:clrpick.color invisible:chkvisible.checked
			-- For NonVray User replace the line above with the following code:
			-- positionarray [i] = omnilight pos:gv */  subdvis: NOTAVAILABLE */  multiplier: lmultiplier.value */  Size: NOTAVAILABLE */  rgb: clrpick.color */ invisible: NOTAVAILABLE */ 
			
			max views redraw
			
		) --ende for loop
	
	)
)
	
on btndelete pressed do
(

	delete positionarray
	positionarray = #()
	
)

on sctype changed thestate2 do
(
	if sctype.state == 1 then 
	(

		addmodifier pick.object (Edit_Mesh())
		gnv = getnumverts pick.object
	
		for i = 1 to gnv by ddsteps.selected as integer do
		(
	
			progress.value = 100.*i/Positionarray.count 
			gv = getvert pick.object i 
			positionarray [i] = vraylight type:2 pos:gv subdivs:lsubdivs.value multiplier: lmultiplier.value size0:lradius.value color:clrpick.color invisible:chkvisible.checked
			-- For NonVray User replace the line above with the following code:
			-- positionarray [i] = omnilight pos:gv */  subdvis: NOTAVAILABLE */  multiplier: lmultiplier.value */  Size: NOTAVAILABLE */  rgb: clrpick.color */ invisible: NOTAVAILABLE */ 
			
			max views redraw
			
		) --ende for loop
	)

	if sctype.state == 2 then
	(
	
		addmodifier pick.object (Edit_Poly())
		gnv = getnumfaces pick.object
	
		for i = 1 to gnv by ddsteps.selected as integer do
		(
	
			progress.value = 100.*i/Positionarray.count 
			gv = polyop.getfacecenter pick.object i 
			positionarray [i] = vraylight type:2 pos:gv subdivs:lsubdivs.value multiplier: lmultiplier.value size0:lradius.value color:clrpick.color invisible:chkvisible.checked
			-- For NonVray User replace the line above with the following code:
			-- positionarray [i] = omnilight pos:gv */  subdvis: NOTAVAILABLE */  multiplier: lmultiplier.value */  Size: NOTAVAILABLE */  rgb: clrpick.color */ invisible: NOTAVAILABLE */ 
			
			max views redraw
			
		) --ende for loop
	)
)

on btncolors pressed do 
(
for i = 1 to positionarray.count do
(
	
positionarray [i].color = [random 0 255, random 0 255, random 0 255]
	
)
	
)
on btnrender pressed do 
(
	render ()
)

on help pressed do
(
	
	messagebox ("The Light Placer places VRaySphereLights on every Vertex of an specific object. \n
\n
1.: Press on Pick Object to select an object to place the lights on. \n
2.: Manipulate the settings of the lights. \n
3.: Optionally you can delete all the lights by clicking on Delete Lights. \n \n \n Pay Attention that you delete all the old lights before youll make bigger changes like the place or the stepsof the lights. \n \n \n \n \n by xcEmUx '2011 \n http:\\\www.xcEmUx.DAPortfolio.com" )
	
)


) --ende rollout

createdialog Lightplacer 125 385