macroScript Staircreator category:"EmuScripts" buttontext:"StairCreator" 
(
rollout StairCreatorRollout "StairCreator" width:210 height:250
(
	label lbl
	label lbl2
	spinner sldAnzahl  "Number of Stairs: "  type:#integer  range:[0,100,10] align:#left
	spinner sldHhe    "Step Height:         " type:#float range:[0,40,2] align:#left
	spinner sldBreite   "Step Width:          " type:#float range:[0,40,10] align:#left
	spinner sldLnge   "Step Length:        " type:#float range:[0,40,20] align:#left
	spinner sldSpaceX "Space [X]:            " type:#float range:[0,25,5] align:#left
	spinner sldSpaceZ "Space [Z]:            " type:#float range:[0,25,5] align:#left
	spinner sldMidboxhhe "Midbox Height:    "type:#float range:[0,10,1.5] align:#left
	
	button btn1 "Ok"  width:150 height:25 tooltext:"Ceate Stairs" align:#center
	
	groupBox grp1 "StairCreator by xcEmUx:     " pos:[5,5] width:200 height:215
	
	Hyperlink Homepage "Portfolio" address:"http://WWW.xcEmUx.DAPortfolio.com" pos:[85,230] width:100 height:50 color:[125,255,255]
	
	on btn1 pressed do
	(
		for i = 1 to sldAnzahl.value do
		(
			xpos=i*sldSpaceX.value	--definiere Position auf X
			zpos=i*sldSpaceZ.value	--definiere Position auf Y
			
			box pos: [xpos, 0, zpos] width:sldBreite.value length:sldLnge.value height:sldHhe.value
			
		)
		
		Anzahl = sldAnzahl.value as float
		Breite = sldBreite.value as float
		Hhe = sldHhe.value as float
		SpaceX = sldSpaceX.value as float
		SpaceZ = sldSpaceZ.value as float
	
		X = Anzahl * Breite + Anzahl * (SpaceX - Breite) as float	--definiere untere Lnge des Dreiecks (Ankathete)
		Z = Anzahl * Hhe + Anzahl * (SpaceZ - Hhe) as float	--definiere seitliche Lnge des Dreiecks (Gegenkathete
		Lnge = sqrt (X^2 + Z^2)	--Berechne die Hypothenuse mit dem Satz des Pythagoras
		
		box  name:"Midbox" width:Lnge length:5 height:sldMidboxhhe.value	--erstelle mittlere Box
		select $Midbox
		BoxRotation = 180 - (atan (Z as float/ X as float)) as float	--rotiere Box um Winkel Alpha von Dreieck [X,Z,Lnge]
		rotation_box = eulerangles 0 BoxRotation 0	--definiere Rotation
		rotate $  rotation_box	--rotiere Box
		move $ [X/1.9, 0, Z/1.9]	--bewege Box in die richtige Position		
		
	)	
)

createDialog StairCreatorRollout 210 250 -- GUI anzeigen

)