macroscript TapeLength category:"EmuScripts" tooltip:"Show Tape Length in Viewport"
(
	local TapeObjs = #()
	local IsEnabled = false
	
	fn ShowLength = 
	(
		gw.settransform (matrix3 1)
		TapeObjs = for o in objects where classof o == Tape and  not o.ishidden collect o
		
		for i= 1 to TapeObjs.count do
		(			
			TapePos = TapeObjs[i].pos 
			
			TapeLength = (units.formatvalue TapeObjs[i].length) as string
			TapeDistance = (units.formatvalue (distance TapeObjs[i] TapeObjs[i].target)) as string
			
			gw.text Tapepos TapeDistance color: yellow  	-- use for distance between tape + target
			-- gw.text Tapepos TapeLength color: yellow 				-- use for actual length, shown in tape helper object (to use take away those "--" s  ;D)
			
		) -- end for-loop
			gw.enlargeupdaterect #whole
			gw.updateScreen()
	) -- end fn ShowLength
	
	on ischecked return isenabled
		
	on execute do
	(
		isenabled = not isenabled
		
		if isenabled == true then
			registerRedrawViewsCallback ShowLength
		else
			unregisterRedrawViewsCallback ShowLength
	) -- end on execute

) -- end MacroScript