try
(
rollout UVWRandomizer "UVW Map Randomizer"
(
	checkbutton chkRandomize "Randomize UVW Maps"  checked: true highlightcolor:orange tooltip: "Randomize all UVWMap Modifiers in Selection" height:20
	checkbutton chkAddUVW "Add UVWMap Modifier" checked: true highlightcolor:orange tooltip: "Add UVWMap Modifier with random values to Objects without UVWMap" height:20
	button btnExecute "Randomize" width: 120 height:18
	
	
	on btnExecute pressed do
	(
		if UVWObjects != #() then UVWObjects = #()
		if OtherObjects != #() then OtherObjects = #()
		
		for obj in selection do
		(
			if selection != undefined and (try(obj.UVWMap)catch(undefined)) != undefined then
				append UVWObjects obj
			else
				append OtherObjects obj
			
		)
			
		if chkRandomize.checked == true then
		(
			for i = 1 to UVWObjects.count do
			(
				a = random 1 4
				
				modPanel.setCurrentObject UVWObjects[i].modifiers[#UVW_Map]
				subobjectLevel = 1
				
				if a == 1 then
				(
					UVWObjects [i].modifiers[#uvwmap].gizmo.position = [random 1 1000, random 1 1000, random 1 1000]
				)
				if a == 2 then
				(
					UVWObjects [i].modifiers[#uvwmap].uflip = true
					UVWObjects [i].modifiers[#uvwmap].gizmo.position = [random 1 1000, random 1 1000, random 1 1000]
				)
				if a == 3 then
				(
					UVWObjects [i].modifiers[#uvwmap].uflip = true
					UVWObjects [i].modifiers[#uvwmap].vflip = true
					UVWObjects [i].modifiers[#uvwmap].gizmo.position = [random 1 1000, random 1 1000, random 1 1000]
				)
				if a == 4 then
				(
					UVWObjects [i].modifiers[#uvwmap].uflip = true
					UVWObjects [i].modifiers[#uvwmap].vflip = true
					UVWObjects [i].modifiers[#uvwmap].wflip = true
					UVWObjects [i].modifiers[#uvwmap].gizmo.position = [random 1 1000, random 1 1000, random 1 1000]
				)
				
			) -- end for-loop - UVW Objects
		) -- end if chkRandomize checked

		if chkAddUVW.checked == true then
		(
			for i = 1 to OtherObjects.count do
			(
				addmodifier Otherobjects[i] (UVWMap maptype: 4 length:10 width:10 height:10)
				modPanel.setCurrentObject otherobjects[i].modifiers[#UVW_Map]
				subobjectLevel = 1
				OtherObjects[i].modifiers[#uvwmap].gizmo.position = [random 1 1000, random 1 1000, random 1 1000]
			) -- end for-loop - Other Objects
		) -- end if chkAddUVW checked
	) -- end btnExecute
) -- end rollout

rollout Ueber "About"
(
	hyperlink link1 "by xcEmUx"   color: white hovercolor: orange visitedcolor: gray address: "http:\\\www.xcEmUx.DAPortfolio.com" align:#center
)

Rolloutfloat = newRolloutFloater "UVW Map Randomizer" 140 130
addrollout UVWRandomizer Rolloutfloat
addrollout Ueber Rolloutfloat
ueber.open = 0
)
catch
(
)