-- PositionChanger Script by xcEmUx '2011
-- Use and Modifiy on your own risk !
-- http:\\www.xcEmUx.DAPortfolio.com

-- by changing more than two positions, the script will change the positions after the the selection number
-- e.g. the first selected object of group 1 will be changed with the first one of group 2, etc. 


rollout PositionChangerRollout "Position Changer 1.0" width:420 height:215
(
	groupBox grp1 "Single Objects" pos:[16,16] width:175 height:160
	groupBox grp2 "Multiple Objects" pos:[208,16] width:195 height:160
	pickbutton pick1 "Select Object 1" pos:[32,56] width:93 height:25
	pickbutton pick2 "Select Object 2" pos:[32,96] width:93 height:25
	button btn3 "Select ObjectSet 1" pos:[224,56] width:96 height:25
	button btn4 "Select ObjectSet 2" pos:[224,96] width:96 height:25
	button btn5 "Change Positions" pos:[32,144] width:144 height:24
	button btn6 "Change Positions" pos:[224,144] width:144 height:24
	button btn9 "?" pos:[320,61] width:20 height:20
	button btn10 "?" pos:[320,101] width:20 height:20
	button btn7 "?" pos:[125,61] width:20 height:20
	button btn8 "?" pos:[125,101] width:20 height:20
	button btnhelp "?" pos:[375,190] width:22 height:22
	checkbox chk1 "In Use" enabled:false pos:[345,68] checked: false
	checkbox chk2 "In Use" enabled:false pos:[345,108] checked: false
	hyperlink link1 "by xcEmUx" pos:[16,192] width:72 height:15 color: white hovercolor: orange visitedcolor: gray address: "http:\\\www.xcEmUx.DAPortfolio.com"
	
	on pick1 picked obj do
	(
		pick1.text = obj.name
	)--end pick1
	
	on pick2 picked obj do
	(
		pick2.text = obj.name
	)--end pick2
	
	on btn5 pressed do
	(
		if pick1.object != undefined and pick2.object != undefined then
		(
			pos1 = pick1.object.position
			pos2 = pick2.object.position
			
			pick1.object.position = pos2
			pick2.object.position = pos1
		)
		
	) -- end btnexecute
	
	on btn3 pressed do
(
	if selection != undefined and selection.count > 1 then
	(
		global objects1 = for i = 1 to $.count collect selection [i]
		
		global position1 = for i = 1 to $.count collect Selection [i].pos as point3
		
		chk1.checked = true
	)	
	
	
)--end btnsel1

on btn4 pressed do
(
	if selection != undefined and selection.count > 1 then
		
	(
		
	global objects2 = for i = 1 to $.count collect selection [i]
	
	global position2 = for i = 1 to $.count collect Selection [i].pos as point3
		
	chk2.checked = true
	
	)	
	
)--end btnsel2

on btn6 pressed do
(	
	if objects1.count == objects2.count then
	(
		for i = 1 to objects1.count do
		(
			objects1 [i].pos = position2 [i]
			objects2 [i].pos = position1 [i]
		)--end forloop
	) --end if
		
	if objects1.count != objects2.count then
		(
			messagebox "The Selection Counts have to be equal. \n Please correct your selections." title: "Error"
		)--end if
		
)--end btnchangepos

on btn7 pressed do
(
	if pick1.object != undefined then
		
		global pick1infos = pick1.object as string
	
		rollout pick1InfoRoll "Selection Info:"
		(
			label infolabel "Selection Info:"
				on pick1inforoll open do
					(
						infolabel.text = pick1infos
					)
		)


		createdialog pick1InfoRoll 400 30
)

on btn8 pressed do
(
		if pick2.object != undefined then
		
		global pick2infos = pick2.object as string
	
		rollout pick2InfoRoll "Selection Info:"
		(
			label infolabel2 "Selection Info:"
				on pick2inforoll open do
					(
						infolabel2.text = pick2infos
					)
		)

		createdialog pick2InfoRoll 400 30
)

on btn9 pressed do
(
			if objects1 != undefined then
		
		global infos1 = ""
	
		rollout InfoRoll1 "Selection Info:"
		(
			label infolabel3 "Selection Info:" align:#left pos: [5,5] width:490 height: 490
				on inforoll1 open do
					(
						local objectinfo1 = for i = 1 to objects1.count collect objects1 [i].name
						
						for i = 1 to objects1.count do
						(
							
							infos1 += " - " + objectinfo1[i] + " \n"
							
						)
						infolabel3.text = infos1
					)
		)

		createdialog InfoRoll1 500 500
)

on btn10 pressed do
(
		if objects2 != undefined then
		
		global infos2 = ""
	
		rollout InfoRoll2 "Selection Info:"
		(
			label infolabel4 "Selection Info:" align:#left pos: [5,5] width:490 height: 490
				on inforoll2 open do
					(
						local objectinfo2 = for i = 1 to objects2.count collect objects2 [i].name
						
						for i = 1 to objects2.count do
						(
							
							infos2 += " - " + objectinfo2[i] + " \n"
							
						)
						infolabel4.text = infos2
					)
		)

		createdialog InfoRoll2 500 500
)

on btnhelp pressed do 
(
	rollout HelpRollout "Help" 
	(
		label lblHelpRollout "The Position Changer Script changes the position of two objects or of a whole selection. 
			\n If you want to change the position of two selection groups, follow the following steps: \n 
			\n 1.: Select all the objects of the first group. 
			\n 2.: Click on ''SelectObjectSet1'' . 
			\n 3.: Repete the steps 1 and 2 for the other selection group, \n       just click on ''SelectObjectSet2''. 
			\n 4.: Click on ''Change Positions. \n \n 
			\n If you want to change only two Positions, \n just pick the objects with help of the two pickbuttons on the left.
			\n \n \n 									by xcEmUx '2011
			\n \n Click on the '?' Buttons to see the objects currently loaded as selection sets." width: 500 height: 500 pos:[5,5]
	)
	
	createdialog HelpRollout 450 300
)
	
)--end rollout Main


createdialog PositionChangerRollout